public class Femme extends Humain {

	protected int fertilite;

	Femme(String nom) {
		this(0,0,nom,0);
	}

	Femme(int age, int poids, String nom, int fertilite) {
		super(age,poids,nom);
		this.fertilite = fertilite;
	}

    int getFertilite() {
        return fertilite;
    }

	public void vieillir() {
		super.vieillir();
		if (age == 15) {
			fertilite = loto.nextInt(101);
		}
		if (age <= 20) poids = 3+(int)(2.6*age);
		else if (age >= 50) poids += (age % 2);
	}

	// ajout d'un paramètre boolean afin d'éviter de grossir (cf. solution TP1 pour la régulation des naissances)
	public Humain rencontre (Humain h, boolean doGrowth) {

		// stoppe directement si h est une instance de Femme
		if (h.isFemme() || h.isFille()) return null;

		Humain bebe = null;
		int chance;
		int sexe;

		if ((age > 15) && (age < 50) && (h.getAge() > 15) && (poids < 150) && (h.getPoids() < 150)) {

			chance = loto.nextInt(101);

			if (chance < fertilite) {

				sexe = loto.nextInt(101);

				if (sexe < 50) {
					bebe = new Garcon("garcon"+nom+"-"+h.getNom());
				}
				else {
					bebe = new Fille("fille"+nom+"-"+h.getNom());
				}

				if (doGrowth) {
					grossir(10);
					h.grossir(loto.nextInt(21));
				}
			}
		}
		return bebe;
	}

	protected void setEsperanceVie() {
		super.setEsperanceVie();
		// moyenne de 55 et 95 = 75, donc 5 de plus que la base
		esperanceVie += 5;
		// tirage aléatoire de +/- 20
		esperanceVie += loto.nextInt(41) - 20;
	}

	public boolean isFemme() {
		return true;
	}

	// pour que le tri se passe toujours bien, il faut que les conditions de comparaisons
	// soient identiques entre homme et femme,
	public int compareTo(Humain h) {
		// utilise la comparaison générale sur l'âge
		int ret = super.compareTo(h);
		// si pas le même âge, la valeur reste la même
		if (ret != 0) return ret;
		// sinon, si h est un homme, on la met après
		if (h.isHomme()) return -1;
		// sinon, 2 femmes du même âge sont consiédrées comme égale
		return 0;
	}
}
