import java.util.*;

class Population {

	private ArrayList<Humain> pop;

	Population() {
		pop = new ArrayList<Humain>();
	}

	public ArrayList<Humain> getPop() {
		return pop;
	}

	public void vider() {
		pop.clear();
	}

	public void addPopulation(Population p) {
		pop.addAll(p.pop);
	}

	public Humain getHumain(int index) {
		return pop.get(index);
	}

	public void addHumain(Humain h) {
		pop.add(h);
	}

	public Humain removeHumain(Humain h) {

		boolean ok = pop.remove(h);
		if (ok) return h;
		return null;
	}

	public Humain removeHumain(int index) {
		return pop.remove(index);
	}

	public int taille() {
		return pop.size();
	}

	public void vieillir() {

	    // Rq : en utilisant un ListIterator (au lieu d'un simple Iterator, on est sur que l'on
        // peut ajouter un individu sans que cela plante.
		ListIterator<Humain> it = pop.listIterator();
		Humain h;

		while (it.hasNext()) {
			h = it.next();
			h.vieillir();
			// test passage adulte
            if (h.getAge() == 18) {
                Humain newOne = null;
                String name = h.getNom();
                if (h.isGarcon()) {
                    name = name.replaceFirst("garcon", "homme");
                    newOne = new Homme(h.getAge(), h.getPoids(), name, ((Garcon)h).getBatifolage());
                }
                else {
                    name = name.replaceFirst("fille", "femme");
                    newOne = new Femme(h.getAge(), h.getPoids(), name, ((Fille)h).getFertilite());
                }
                it.remove();
                it.add(newOne);
            }
			// test de fin de vie
			if (h.isDead() == true) {
				System.out.print("  :-( mort de :");
				h.print();
				// suppression de l'humain
				it.remove();
			}
		}
	}

	public void print() {

		for(Humain h : pop) {
			h.print();
		}
	}

	public void trier() {
		Collections.sort(pop);
	}

}
